bits 16
jmp main		;Go to main

; -- VARS --
ciao db 'come va?', 0

; -- INCLUDE --
%INCLUDE 'libs\screen.asm'		; Screen libs
%INCLUDE 'libs\string.asm'		; String libs
%include "inc\Gdt.inc"			; Gdt routines
%include "inc\A20.inc"			; A20 enabling

main:

set_stack:
	cli							; clear interrupts
	mov	ax, 0					; null segments
	mov	ds, ax
	mov	es, ax
	mov	ax, 0x9000				; stack begins at 0x9000-0xffff
	mov	ss, ax
	mov	sp, 0xFFFF
	sti

	call	InstallGDT			; install GDT

	call	EnableA20_KKbrd_Out	; Enable A20 Gate

pmode:
	cli							; clear interrupts
	mov	eax, cr0				; set bit 0 in cr0 // Enter protected mode
	or	eax, 1
	mov	cr0, eax

	jmp	CODE_DESC:code_access	; far jump to fix CS

	bits 32
	
code_access:
	mov		ax, DATA_DESC		; set data segments to data selector (0x10)
	mov		ds, ax
	mov		ss, ax
	mov		es, ax
	mov		esp, 90000h			; stack begins from 90000h
	
call os_set_graphics_mode
call os_draw_background